import SuperHeaders from "@mjackson/headers";
export class TypedResponse extends Response {
    constructor(body, init) {
        if (init === null || init === void 0 ? void 0 : init.headers) {
            init.headers = new SuperHeaders(init.headers);
        }
        super(body, init);
        this.response = new Response(body, init);
    }
    json() {
        return this.response.json();
    }
    text() {
        return this.response.text();
    }
    formData() {
        return this.response.formData();
    }
}
export class TypedRequest extends Request {
    constructor(input, init) {
        if (init === null || init === void 0 ? void 0 : init.headers) {
            init.headers = new SuperHeaders(init.headers);
        }
        super(input, init);
        this.request = new Request(input, init);
    }
    json() {
        return this.request.json();
    }
    text() {
        return this.request.text();
    }
    formData() {
        return this.request.formData();
    }
}
